# cwl_utils.parser.utils

CWL parser utility functions.

## Functions

`convert_stdstreams_to_files`(process) | Convert stdin, stdout and stderr type shortcuts to files.
`load_inputfile_by_uri`(version, path[, loadingOptions]) | Load a CWL input file from a URI or a path.
`load_inputfile`(version, doc[, baseuri, loadingOptions]) | Load a CWL input file from a serialized YAML string or a YAML object.
`load_inputfile_by_string`(version, string, uri[, ...]) | Load a CWL input file from a serialized YAML string.
`load_inputfile_by_yaml`(version, yaml, uri[, ...]) | Load a CWL input file from a YAML object.
`load_step`(step) |
`static_checker`(workflow) | Check if all source and sink types of a workflow are compatible before run time.
`type_for_source`(process, sourcenames[, parent, ...]) | Determine the type for the given sourcenames.
`type_for_step_input`(step, in_, cwlVersion) | Determine the type for the given step output.
`type_for_step_output`(step, sourcename, cwlVersion) | Determine the type for the given step output.
`param_for_source_id`(process, sourcenames[, parent, ...]) |

## Module Contents

cwl_utils.parser.utils.convert_stdstreams_to_files(process)

  Convert stdin, stdout and stderr type shortcuts to files.

  Parameters:

    process (cwl_utils.parser.Process)

  Return type:

    None

cwl_utils.parser.utils.load_inputfile_by_uri(version, path, loadingOptions=None)

  Load a CWL input file from a URI or a path.

  Parameters:

    - version (str)

    - path (str | pathlib.Path)

    - loadingOptions (cwl_utils.parser.LoadingOptions | None)

  Return type:

    Any

cwl_utils.parser.utils.load_inputfile(version, doc, baseuri=None, loadingOptions=None)

  Load a CWL input file from a serialized YAML string or a YAML object.

  Parameters:

    - version (str)

    - doc (Any)

    - baseuri (str | None)

    - loadingOptions (cwl_utils.parser.LoadingOptions | None)

  Return type:

    Any

cwl_utils.parser.utils.load_inputfile_by_string(version, string, uri, loadingOptions=None)

  Load a CWL input file from a serialized YAML string.

  Parameters:

    - version (str)

    - string (str)

    - uri (str)

    - loadingOptions (cwl_utils.parser.LoadingOptions | None)

  Return type:

    Any

cwl_utils.parser.utils.load_inputfile_by_yaml(version, yaml, uri, loadingOptions=None)

  Load a CWL input file from a YAML object.

  Parameters:

    - version (str)

    - yaml (Any)

    - uri (str)

    - loadingOptions (cwl_utils.parser.LoadingOptions | None)

  Return type:

    Any

cwl_utils.parser.utils.load_step(step)
  Parameters:

    step (cwl_utils.parser.WorkflowStep)

  Return type:

    cwl_utils.parser.Process

cwl_utils.parser.utils.static_checker(workflow)

  Check if all source and sink types of a workflow are compatible before run time.

  Parameters:

    workflow (cwl_utils.parser.Workflow)

  Return type:

    None

cwl_utils.parser.utils.type_for_source(process, sourcenames, parent=None, linkMerge=None, pickValue=None)

  Determine the type for the given sourcenames.

  Parameters:

    - process (cwl_utils.parser.Process)

    - sourcenames (str | list[str])

    - parent (cwl_utils.parser.Workflow | None)

    - linkMerge (str | None)

    - pickValue (str | None)

  Return type:

    Any

cwl_utils.parser.utils.type_for_step_input(step, in_, cwlVersion)

  Determine the type for the given step output.

  Parameters:

    - step (cwl_utils.parser.WorkflowStep)

    - in_ (cwl_utils.parser.WorkflowStepInput)

    - cwlVersion (str)

  Return type:

    Any

cwl_utils.parser.utils.type_for_step_output(step, sourcename, cwlVersion)

  Determine the type for the given step output.

  Parameters:

    - step (cwl_utils.parser.WorkflowStep)

    - sourcename (str)

    - cwlVersion (str)

  Return type:

    Any

cwl_utils.parser.utils.param_for_source_id(process, sourcenames, parent=None, scatter_context=None)
  Parameters:

    - process (cwl_utils.parser.CommandLineTool | cwl_utils.parser.Workflow | cwl_utils.parser.ExpressionTool)

    - sourcenames (str | list[str])

    - parent (cwl_utils.parser.Workflow | None)

    - scatter_context (list[tuple[int, str] | None] | None)

  Return type:

    collections.abc.MutableSequence[cwl_utils.parser.cwl_v1_0.InputParameter | cwl_utils.parser.cwl_v1_0.CommandOutputParameter] | cwl_utils.parser.cwl_v1_0.InputParameter | cwl_utils.parser.cwl_v1_0.CommandOutputParameter | collections.abc.MutableSequence[cwl_utils.parser.cwl_v1_1.CommandInputParameter | cwl_utils.parser.cwl_v1_1.CommandOutputParameter | cwl_utils.parser.cwl_v1_1.WorkflowInputParameter] | cwl_utils.parser.cwl_v1_1.CommandInputParameter | cwl_utils.parser.cwl_v1_1.CommandOutputParameter | cwl_utils.parser.cwl_v1_1.WorkflowInputParameter | collections.abc.MutableSequence[cwl_utils.parser.cwl_v1_2.CommandInputParameter | cwl_utils.parser.cwl_v1_2.CommandOutputParameter | cwl_utils.parser.cwl_v1_2.WorkflowInputParameter] | cwl_utils.parser.cwl_v1_2.CommandInputParameter | cwl_utils.parser.cwl_v1_2.CommandOutputParameter | cwl_utils.parser.cwl_v1_2.WorkflowInputParameter